# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class SimpleConditionDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'field': 'str',
        'comparator': 'str',
        'parameter': 'str'
    }

    attribute_map = {
        'field': 'field',
        'comparator': 'comparator',
        'parameter': 'parameter'
    }

    def __init__(self, field=None, comparator=None, parameter=None, _configuration=None):  # noqa: E501
        """SimpleConditionDefinition - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._field = None
        self._comparator = None
        self._parameter = None
        self.discriminator = None

        self.field = field
        self.comparator = comparator
        self.parameter = parameter

    @property
    def field(self):
        """Gets the field of this SimpleConditionDefinition.  # noqa: E501

        The name of the property to compare.  This should be either a property (e.g. \"cm:name\") or one of the keywords from this list: * size (the size of the content for a node) * mimetype (the mimetype of the content for a node) * encoding (the encoding of the content for a node) * category (a category for the node) * tag (a tag that the node has) * aspect (an aspect that the node has)  For multi-valued properties the condition is satisfied if any of the values match the condition.   # noqa: E501

        :return: The field of this SimpleConditionDefinition.  # noqa: E501
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field):
        """Sets the field of this SimpleConditionDefinition.

        The name of the property to compare.  This should be either a property (e.g. \"cm:name\") or one of the keywords from this list: * size (the size of the content for a node) * mimetype (the mimetype of the content for a node) * encoding (the encoding of the content for a node) * category (a category for the node) * tag (a tag that the node has) * aspect (an aspect that the node has)  For multi-valued properties the condition is satisfied if any of the values match the condition.   # noqa: E501

        :param field: The field of this SimpleConditionDefinition.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and field is None:
            raise ValueError("Invalid value for `field`, must not be `None`")  # noqa: E501

        self._field = field

    @property
    def comparator(self):
        """Gets the comparator of this SimpleConditionDefinition.  # noqa: E501

        The method to compare the property against the parameter.  Depending on the type of the property then different comparators are available: * All types: equals * text: contains, startsWith, endsWith * int/long/float/double/date: greaterThan, lessThan, greaterThanOrEqual, lessThanOrEqual * type: instanceOf  Where a property is multivalued then the condition is true if it is satisfied by any of the values.   # noqa: E501

        :return: The comparator of this SimpleConditionDefinition.  # noqa: E501
        :rtype: str
        """
        return self._comparator

    @comparator.setter
    def comparator(self, comparator):
        """Sets the comparator of this SimpleConditionDefinition.

        The method to compare the property against the parameter.  Depending on the type of the property then different comparators are available: * All types: equals * text: contains, startsWith, endsWith * int/long/float/double/date: greaterThan, lessThan, greaterThanOrEqual, lessThanOrEqual * type: instanceOf  Where a property is multivalued then the condition is true if it is satisfied by any of the values.   # noqa: E501

        :param comparator: The comparator of this SimpleConditionDefinition.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and comparator is None:
            raise ValueError("Invalid value for `comparator`, must not be `None`")  # noqa: E501

        self._comparator = comparator

    @property
    def parameter(self):
        """Gets the parameter of this SimpleConditionDefinition.  # noqa: E501

        The value to compare the field against  # noqa: E501

        :return: The parameter of this SimpleConditionDefinition.  # noqa: E501
        :rtype: str
        """
        return self._parameter

    @parameter.setter
    def parameter(self, parameter):
        """Sets the parameter of this SimpleConditionDefinition.

        The value to compare the field against  # noqa: E501

        :param parameter: The parameter of this SimpleConditionDefinition.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and parameter is None:
            raise ValueError("Invalid value for `parameter`, must not be `None`")  # noqa: E501

        self._parameter = parameter

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SimpleConditionDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimpleConditionDefinition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SimpleConditionDefinition):
            return True

        return self.to_dict() != other.to_dict()
